﻿/*
Copyright © Jonathan Schnittger 2013 
Do not alter, reproduce or redistribute without attribution
*/
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Coding.Exercise
{
    class Program
    {
        static void Main(string[] args)
        {
            Exception exError = null;

            /*
            
            */

            SqlConnectionStringBuilder builder = new SqlConnectionStringBuilder();
            builder.IntegratedSecurity = true;
            builder.ConnectTimeout = 30;
            builder.DataSource = @"SERVER\INSTANCE";
            builder.InitialCatalog = "Database";


            using (SqlConnection connection = new SqlConnection(builder.ConnectionString))
            {
                User_DataMapper user_mapper = new User_DataMapper(connection);
                List<User> users = user_mapper.Select(out exError);

                if (exError != null)
                {
                    //do something with the users list
                }
                else
                    //Report and handle the exception
                    MessageBox.Show("Unable to get list of users, " + exError.Message);
            }
        }
    }
}
