﻿/*
Copyright © Jonathan Schnittger 2013 
Do not alter, reproduce or redistribute without attribution
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Data;
using System.Data.SqlClient;

namespace Coding.Exercise
{
    /// <summary>
    /// A simple user class
    /// </summary>
    public class User
    {
        /// <summary>
        /// A nullable user id
        /// </summary>
        public int? UserID = null;

        /// <summary>
        /// The username
        /// </summary>
        public string Username = null;
    }

    public class User_DataMapper : IDataMapper<User>
    {
        public User_DataMapper(SqlConnection connection) : base(connection) { }

        public override List<User> Select(out Exception exError)
        {
            List<User> returnValue = new List<User>();
            exError = null;

            try
            {
                if (this.Connection.State != ConnectionState.Open)
                    this.Connection.Open();

                using (SqlCommand command = new SqlCommand("SELECT [UserID], [Username] FROM dbo.[User]", (SqlConnection)this.Connection))
                {
                    using (SqlDataReader reader = command.ExecuteReader())
                    {
                        while (reader.Read())
                            returnValue.Add(new User() { UserID = reader.GetInt32(0), Username = reader.GetString(1) });
                    }
                }
            }
            catch (InvalidOperationException invalid)
            {
                exError = invalid;
            }
            catch (Exception ex)
            {
                exError = ex;
            }

            return returnValue;
        }

        public override bool Create(User instance, out Exception exError)
        {
            throw new NotImplementedException();
        }

        public override User Read(int ID, out Exception exError)
        {
            throw new NotImplementedException();
        }

        public override User Read(User instance, out Exception exError)
        {
            throw new NotImplementedException();
        }

        public override bool Update(User instance, out Exception exError)
        {
            throw new NotImplementedException();
        }

        public override bool Delete(int ID, out Exception exError)
        {
            throw new NotImplementedException();
        }

        public override bool Delete(User instance, out Exception exError)
        {
            throw new NotImplementedException();
        }
    }
}